from util import *
import subprocess
import os

class DBProxy:
    def __init__(self, config):
        self.running = True
        self.host = config['DBHOST']
        self.back_port = randomPort()
        self.addr_port = config['DBPORT']
        self.admin_user = config['DBUSER']
        self.admin_pass = config['DBPASS']
        self.script = "../"+config['configFile']+"/db_admin.lua"
        self.logDir = "../"+config['configFile']+"/"
        self.script_template = "../src/db_admin_template.lua"
        self.banned_CMD = "db_banned.log"
        self.logFolder = "../" + config['configFile'] + "/logs"
        self.logs = "db_s_logs.log"
        self.long_logs = "db_l_logs.log"
        subprocess.call(["cp", "/etc/mysql/my.cnf", "/etc/mysql/my.cnf.orig"])
        fd = open("/etc/mysql/my.cnf").read()
        fd2 = ""
        for l in fd.split("\n"):
            if not l.strip().startswith("port"):
                fd2 += l + "\n"
            else:
                fd2 += "port = %d\n" % (self.back_port)
        f = open("/etc/mysql/my.cnf", "w")
        f.write(fd2)
        f.close()
        subprocess.call(["service", "mysql", "restart"])        
        self.b_dict = {}
        if not os.path.isdir("../"+config['configFile']):
            subprocess.call(["mkdir", "../"+config['configFile']])
        if not os.path.isdir(self.logFolder):
            subprocess.call(["mkdir", self.logFolder])
        try:
            with open(self.logFolder + "/" + self.banned_CMD) as b:
                for line in b:
                    self.b_dict[line.rpartition(";")[2]] = int(line.rpartition(";")[0])
        except IOError:
            subprocess.Popen(["touch", self.logFolder + "/" + self.banned_CMD])
        try:
            test = open(self.logFolder + "/" + self.logs)
            test.close()
        except IOError:
            subprocess.Popen(["touch", self.logFolder + "/" + self.logs])
        try:
            test = open(self.logFolder + "/" + self.long_logs)
            test.close()
        except IOError:
            subprocess.Popen(["touch", self.logFolder + "/" + self.long_logs])
        self.writeAdminScript()
        

    def spArgs(self):
        return {}

    def run(self):
        path = os.path.dirname(os.path.realpath(__file__)) + "/"
        proxy = subprocess.Popen(["mysql-proxy", "--admin-username", self.admin_user,
                         "--admin-password", self.admin_pass, 
                         "--admin-lua-script", path + self.script, 
                         "--proxy-address", self.host + ":" + str(self.addr_port),
                         "--proxy-backend-addresses", self.host + ":" + str(self.back_port),
                         "--proxy-lua-script", path + self.script])

    def reportCrash(self):
        log_val = ""
        with open(self.logFolder + "/" + self.logs) as log_f:
            for line in log_f:
                log_val = line.rpartition(";")[2]
        if log_val in self.b_dict:
            self.b_dict[str(log_val)] += 1
        else:
            self.b_dict[str(log_val)] = 1
        b_file = open(self.logFolder + "/" + self.banned_CMD, 'r+')
        for entry in self.b_dict.iterkeys():
            b_file.write(str(self.b_dict[entry]) + ";" + entry)
        b_file.truncate()
        b_file.close()
            

    def clean(self):
        subprocess.call(["cp", "/etc/mysql/my.cnf.orig", "/etc/mysql/my.cnf"])
        subprocess.call(["service", "mysql", "restart"])
        subprocess.Popen(["pkill", "mysql-proxy"])

    def writeAdminScript(self):
        newScript = ""
        with open(self.script_template) as admin:
            for line in admin:
                if line.strip().partition(" ")[2].partition(" ")[0] == "file_name":
                    newScript += "   local file_name = \"" + self.logDir + "\"\n"
                else:
                    newScript += line
        subprocess.call(["touch",self.script])
        admin = open(self.script, "w")
        admin.write(newScript)
        admin.close()
