# Network Proxy for the 6.858 2013 Final Project: Torchwood by Tom Boning
import logging
from util import *
import tcp_proxy
import thread

class NetworkProxy:
    def __init__(self, config):
        logging.basicConfig(level=logging.DEBUG, format='%(asctime)s: %(message)s')
        print 'Created network proxy'
        self.blocked_requests = []
        self.running = True
        self.servers = {}
        self.configFile = config['configFile']
        # Get ports from config
        ports = config['PORTS']
        # Setup iptables
        self.portMap = []
        self.setupPorts(ports)
        # Create proxy on ports
        # We assume that host is localhost
        for (p,p2) in self.portMap:
            # Set up a proxy for that.
            server = tcp_proxy.TCPFilter(('0.0.0.0',p2),('localhost',p))
            self.servers[(p,p2)] = server
            server.load_blocked_requests(self.configFile + '.netblocked.' + str(p))


    def setupPorts(self, ports):
        # Setup iptables
        for port in ports:
            p = int(port)
            p2 = forward(p)
            self.portMap.append((p,p2))

    def clean(self):
        # Destroy iptable rules
        for (p,p2) in self.portMap:
            self.servers[(p,p2)].dump_blocked_requests(self.configFile + '.netblocked.' + str(p))
            self.servers[(p,p2)].running = False
            destroyForward(p,p2)

    def spArgs(self):
        return {}

    def run(self):
        threads = []
        for (p,p2) in self.portMap:
            print'Created thread for port ', p
            threads += [thread.start_new_thread(self.servers[(p,p2)].run, ())]
        while 1:
            if not self.running:
                return


    def reportCrash(self):
        for server in self.servers.itervalues():
            server.block_last_request()
